import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
import { httpRuntimeTemplateLib } from "../external-packages/ts-http-runtime.js";
export function getClientcontextDeclarationRef(client) {
  return ay.refkey(client, "declaration");
}
export function ClientContextDeclaration(props) {
  const ref = getClientcontextDeclarationRef(props.client);
  const namePolicy = ts.useTSNamePolicy();
  const name = namePolicy.getName(`${props.client.name}Context`, "class");
  return _$createComponent(ts.InterfaceDeclaration, {
    "export": true,
    name: name,
    refkey: ref,
    get ["extends"]() {
      return httpRuntimeTemplateLib.Client;
    }
  });
}
//# sourceMappingURL=client-context-declaration.js.map