import { createComponent as _$createComponent } from "@alloy-js/core/jsx-runtime";
import * as ay from "@alloy-js/core";
import * as ts from "@alloy-js/typescript";
import { useClientLibrary } from "@typespec/http-client";
import { ClientContext } from "./client-context/client-context.js";
import { ClientOperations } from "./client-operation.js";
export function OperationsDirectory(props) {
  const {
    topLevel: clients
  } = useClientLibrary();
  // If it is the root client, we don't need to create a directory
  return _$createComponent(ay.For, {
    each: clients,
    joiner: ",",
    line: true,
    children: client => _$createComponent(ay.StatementList, {
      get children() {
        return [_$createComponent(ClientOperations, {
          client: client
        }), _$createComponent(ClientContext, {
          client: client
        }), _$createComponent(SubClients, {
          client: client
        })];
      }
    })
  });
}
export function SubClients(props) {
  const subClients = props.client.subClients;
  return _$createComponent(ay.For, {
    each: subClients,
    children: subClient => {
      const namePolicy = ts.useTSNamePolicy();
      const subClientName = namePolicy.getName(subClient.name, "variable");
      return _$createComponent(ay.SourceDirectory, {
        path: subClientName,
        get children() {
          return [_$createComponent(ClientOperations, {
            client: subClient
          }), _$createComponent(ClientContext, {
            client: subClient
          }), _$createComponent(SubClients, {
            client: subClient
          })];
        }
      });
    }
  });
}
//# sourceMappingURL=client-directory.js.map